/**
 * 
 */
package org.processmining.models.performancemeasurement.dataelements;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Queue;

import org.deckfour.xes.classification.XEventClass;
import org.processmining.models.fuzzyperformancediagram.FPDNode;

/**
 * @author arya
 * @email arya.adriansyah@gmail.com
 * @version Apr 14, 2009
 */
public class AccumulatedFPDNodeInstanceBars {
	private Map<FPDNode, Map<XEventClass, Map<Integer, Queue<ActivityInstanceBar>>>> accumulatedNodeInstanceBars; // store accumulated activity instance bar
	private Map<Integer, Date> mapCaseIDStartTime;

	public AccumulatedFPDNodeInstanceBars(
			Map<FPDNode, Map<XEventClass, Map<Integer, Queue<ActivityInstanceBar>>>> accumulatedNodeInstanceBars) {
		this.accumulatedNodeInstanceBars = accumulatedNodeInstanceBars;
		mapCaseIDStartTime = new HashMap<Integer, Date>();
	}

	/**
	 * @return the accumulatedNodeInstanceBars
	 */
	public Map<FPDNode, Map<XEventClass, Map<Integer, Queue<ActivityInstanceBar>>>> getAccumulatedNodeInstanceBars() {
		return accumulatedNodeInstanceBars;
	}

	/**
	 * @param accumulatedNodeInstanceBars
	 *            the accumulatedNodeInstanceBars to set
	 */
	public void setAccumulatedNodeInstanceBars(
			Map<FPDNode, Map<XEventClass, Map<Integer, Queue<ActivityInstanceBar>>>> accumulatedNodeInstanceBars) {
		this.accumulatedNodeInstanceBars = accumulatedNodeInstanceBars;
	}

	/**
	 * @return the mapCaseIDStartTime
	 */
	public Map<Integer, Date> getMapCaseIDStartTime() {
		return mapCaseIDStartTime;
	}

	/**
	 * @param mapCaseIDStartTime
	 *            the mapCaseIDStartTime to set
	 */
	public void setMapCaseIDStartTime(Map<Integer, Date> mapCaseIDStartTime) {
		this.mapCaseIDStartTime = mapCaseIDStartTime;
	}

	/**
	 * @param caseID
	 * @param startTimeCase
	 */
	public void addStartTimeCase(int caseID, Date startTimeCase) {
		mapCaseIDStartTime.put(caseID, startTimeCase);
	}

	/**
	 * @param caseID
	 */
	public void removeStartTimeCase(int caseID) {
		mapCaseIDStartTime.remove(caseID);
	}
}
