/**
 * 
 */
package org.processmining.models.shapes;

import java.awt.geom.GeneralPath;
import java.awt.geom.RoundRectangle2D;

import org.processmining.models.fuzzyperformancediagram.FPDNode;

/**
 * @author arya
 * @email arya.adriansyah@gmail.com
 * @version Apr 14, 2009
 */
public class FPDNodeShape extends AbstractShape {
	@SuppressWarnings("unused")
	private FPDNode visualizedFPDNode;

	private double paddingFromBoxToText = 0.0;
	private double branchingBoxWidth = 0.0;

	@SuppressWarnings("unused")
	private FPDNodeShape() {
	};

	public FPDNodeShape(FPDNode visualizedFPDNode, double paddingFromBoxToText, double branchingBoxWidth) {
		this.visualizedFPDNode = visualizedFPDNode;
		this.paddingFromBoxToText = paddingFromBoxToText;
		this.branchingBoxWidth = branchingBoxWidth;
	}

	public GeneralPath getPath(double x, double y, double width, double height) {
		/**
		 * SCALE HEIGHT AND WIDTH OF THIS NODE
		 */
		double m = Math.max(width, height) * .125;

		// Width and height have correct ratio;
		GeneralPath path = new GeneralPath();

		// main border
		java.awt.Shape rect = new RoundRectangle2D.Double(x, y, width, height, m, m);
		path.append(rect, false);

		// line between split boxes and main content
		path.moveTo(new Float(x + paddingFromBoxToText + branchingBoxWidth + paddingFromBoxToText), (float) y);
		path.lineTo(new Float(x + paddingFromBoxToText + branchingBoxWidth + paddingFromBoxToText), new Float(y
				+ height));
		path.closePath();

		// line between main content and join boxes
		path.moveTo(new Float(x - paddingFromBoxToText - branchingBoxWidth - paddingFromBoxToText + width), (float) y);
		path.lineTo(new Float(x - paddingFromBoxToText - branchingBoxWidth - paddingFromBoxToText + width), new Float(y
				+ height));
		path.closePath();

		return path;
	}

}
